﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using System.Diagnostics;
using Infragistics.Windows;

namespace XDG_Print_Images
{
    class Converter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
			string imageLocation;
            try
            {
                Int32 status = System.Convert.ToInt32(value);
                switch (status)
                {
                    case 1:
						imageLocation = @"..\images\circle.png";
						//return BitmapSourceFromImage(Properties.Resources.pentagon);
                        break;
                    case 2:
						imageLocation = @"..\images\pentagon.png";
                         //return BitmapSourceFromImage(Properties.Resources.circle);
                       break;
                    case 3:
                    default:
 						imageLocation = @"..\images\triangle.png";
                        //return BitmapSourceFromImage(Properties.Resources.triangle);
                        break;
                 }
            }
            catch (Exception e) 
            {
                Debug.WriteLine("Exception in Converter!! " + e.Message);
               // return BitmapSourceFromImage(Properties.Resources.triangle);
				imageLocation = @"..\images\triangle.png";
			}

			Uri uri = Utilities.BuildEmbeddedResourceUri(typeof(Converter).Assembly, imageLocation);

			BitmapImage bi = new BitmapImage(uri);

			return bi;
        }

        private static BitmapSource BitmapSourceFromImage(System.Drawing.Image img)
        {
            var memStream = new System.IO.MemoryStream();             
            //save the image to memStream as a png 
            img.Save(memStream, System.Drawing.Imaging.ImageFormat.Png);             
            //gets a decoder from this stream             
            var decoder = new PngBitmapDecoder(memStream, BitmapCreateOptions.PreservePixelFormat | BitmapCreateOptions.IgnoreImageCache, BitmapCacheOption.Default);             

			return decoder.Frames[0];
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
}
